%global momorel 1
%global advanced_branch 1
%global svnrev 2386

Summary:	A lightweight RPC library based on XML and HTTP
Name:		xmlrpc-c
Version:	1.31.04
#Release:	%{momorel}m%{?dist}
Release:	0.%{svnrev}.%{momorel}m%{?dist}
# See COPYING for details.
# The Python 1.5.2 license used by a few files is just BSD.
License:	BSD and MIT
Group:		System Environment/Libraries
URL:		http://xmlrpc-c.sourceforge.net/
%{!?advanced_branch:Source0:   http://dl.sourceforge.net/sourceforge/xmlrpc-c/xmlrpc-%version.tgz}
# generated by 'make svn-sources [SVN_VER=%version SVN_REV=%svnrev]'. Unfortunately,
# upstream does not tag versions so we must fetch from the branch and
# check which version was used for it
%{?advanced_branch:Source0:    xmlrpc-c-%version.tar.xz}

Source100:     dfs.cc
Source101:     dso-fixup

Patch100:       xmlrpc-c-cmake.patch
Patch102:       xmlrpc-c-printf-size_t.patch
Patch105:       xmlrpc-c-longlong.patch
Patch107:       xmlrpc-c-uninit-curl.patch
Patch108:       xmlrpc-c-30x-redirect.patch
Patch109:       xmlrpc-c-check-vasprintf-return-value.patch
Patch110:       xmlrpc-c-include-string_int.h.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	cmake >= 2.4.8-3m
BuildRequires:	curl-devel >= 7.18.2, libxml2-devel, readline-devel, ncurses-devel >= 5.7-17m
BuildRequires:  w3c-libwww-devel >= 5.2.8, openldap-devel >= 2.4.8

%package c++
Summary:	C++ libraries for xmlrpc-c
Group:		System Environment/Libraries
Requires:	%{name} = %{version}-%{release}

%package client
Summary:	C client libraries for xmlrpc-c
Group:		System Environment/Libraries
Requires:	%{name} = %{version}-%{release}

%package client++
Summary:	C++ client libraries for xmlrpc-c
Group:		System Environment/Libraries
Requires:	%{name} = %{version}-%{release}

%package devel
Summary:	Development files for xmlrpc-c based programs
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	%{name}-client = %{version}-%{release}
Requires:	%{name}-client++ = %{version}-%{release}

%package apps
Summary:	Sample XML-RPC applications
Group:		Applications/Internet


%description
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C.


%description c++
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C++.


%description client
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C
clients.

%description client++
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C++
clients.


%description devel
Static libraries and header files for writing XML-RPC applications in
C and C++.


%description apps
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This package contains some handy XML-RPC demo applications.


%prep
%setup -q
%patch100 -p1
%patch102 -p1
%patch105 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1

## not needed...
rm doc/{INSTALL,configure_doc}


%build
CFLAGS="$RPM_OPT_FLAGS"
CXXFLAGS="$RPM_OPT_FLAGS"
case "`gcc -dumpversion`" in
4.6.*)
	# xmlrpc-c.spec-1.21.00 requires this
	CFLAGS="$CFLAGS  -fpermissive"
	CXXFLAGS="$CXXFLAGS  -fpermissive"
	;;
esac
export CFLAGS CXXFLAGS

mkdir -p momonga
cd momonga
export LDFLAGS="-Wl,-as-needed"
cmake .. \
	-D_lib:STRING=%{_lib}			\
	-DMUST_BUILD_CURL_CLIENT:BOOL=ON	\
	-DMUST_BUILD_LIBWWW_CLIENT:BOOL=OFF	\
        -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix}	\
        -DBUILD_SHARED_LIBS:BOOL=ON             \
	-DENABLE_TOOLS:BOOL=ON
make VERBOSE=1 %{?_smp_mflags}

%{__cxx} $RPM_OPT_FLAGS %{SOURCE100} -o depsort


%install
%{__rm} -rf --preserve-root %{buildroot}
cd momonga
make DESTDIR="%{buildroot}" install

chmod +x %{buildroot}%{_libdir}/*.so

%{SOURCE101} "$RPM_BUILD_ROOT" "%_libdir" 'libxmlrpc' $RPM_BUILD_ROOT%_libdir/libxmlrpc*.so.[0-9]

%check
unset PKG_CONFIG_PATH
export PKG_CONFIG_LIBDIR=%{buildroot}%{_libdir}/pkgconfig:%{_libdir}/pkgconfig:%{_datadir}/pkgconfig
PATH=%{buildroot}%{_bindir}:$PATH

_e() {
     echo "\$ $@"
     "$@"
}

set +x
_e xmlrpc-c-config --help
for comp in c++ cgi-server server-util abyss-server client libwww-client; do
	for opt in '--version' '--libs' 'c++2 --libs' 'c++ --libs --static'; do
		_e xmlrpc-c-config "$comp" $opt
	done
done
set -x


%clean
%{__rm} -rf --preserve-root %{buildroot}

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post client   -p /sbin/ldconfig
%postun client -p /sbin/ldconfig

%post c++   -p /sbin/ldconfig
%postun c++ -p /sbin/ldconfig

%post client++   -p /sbin/ldconfig
%postun client++ -p /sbin/ldconfig


%files 
%defattr(-,root,root,-)
%doc doc/*
%{_libdir}/*.so.3*
%exclude %{_libdir}/libxmlrpc_client.so*

%files client
%defattr(-,root,root,-)
%{_libdir}/libxmlrpc_client.so.*

%files c++
%defattr(-,root,root,-)
%{_libdir}/*.so.8*
%exclude %{_libdir}/libxmlrpc_client++.so*

%files client++
%defattr(-,root,root,-)
%{_libdir}/libxmlrpc_client++.so.*

%files devel
%defattr(-,root,root,-)
%{_bindir}/xmlrpc-c-config
%dir %{_includedir}/xmlrpc-c
%{_includedir}/xmlrpc-c/*
%{_includedir}/*.h
%{_libdir}/pkgconfig/*.pc
%{_libdir}/*.so

%files apps
%defattr(-,root,root,-)
%doc tools/xmlrpc/xmlrpc.html
%doc tools/xmlrpc_transport/xmlrpc_transport.html
%{_mandir}/man1/*
%{_bindir}/xmlrpc
%{_bindir}/xmlrpc_transport
%{_bindir}/xml-rpc-api2cpp
%{_bindir}/xmlrpc_cpp_proxy
%{_bindir}/xmlrpc_parsecall
%{_bindir}/xmlrpc_pstream

%exclude %{_bindir}/xml-rpc-api2txt

%changelog
* Sun Sep  9 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.31.04-0.2386.1m)
- update 1.31.04

* Sat Jul  2 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.21.00-0.1851.7m)
- fix build failure; add patch for curl

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.21.00-0.1851.6m)
- rebuild for new GCC 4.6

* Sun Mar 06 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.21.00-0.1851.5m)
- fix CFLAGS and CXXFLAGS for gcc 4.6

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.21.00-0.1851.4m)
- rebuild for new GCC 4.5

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.21.00-0.1851.3m)
- full rebuild for mo7 release

* Sat Jul 24 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.21.00-0.1851.2m)
- rebuild against ncurses-5.7-17m
- enable depsort

* Sat Jul 24 2010 Masahiro Takahata <takahata@momonga-linux.org>
- (1.21.00-0.1851.1m)
- version up 1.21.00
- import patch from Fedora
- exclude %%{_bindir}/xmlrpc_pstream

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.16.6-0.0.1582.2m)
- rebuild against gcc-4.4 and glibc-2.11

* Tue May 12 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.16.6-0.0.1582.1m)
- update to svn revision 1582 based on Fedora 11 (1.16.6-2.1582)

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.14.8-2m)
- rebuild against rpm-4.6

* Sat Jul 26 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (1.14.8-1m)
- update to 1.14.8, advanced version (sync with Fedora)
- no NoSource

* Fri Jul 11 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (1.06.27-1m)
- update to 1.06.27
- add patch200 to enable build with new curl

* Thu Jun  5 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (1.06.07-6m)
- rebuild against openssl-0.9.8h-1m

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.06.07-5m)
- rebuild against gcc43

* Wed Feb 27 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.06.07-4m)
- rebuild against openldap-2.4.8

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.06.07-3m)
- %%NoSource -> NoSource

* Wed Jan  2 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.06.07-2m)
- added patch for gcc43

*  Sun Nov 12 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (1.06.07-1m)
- update to 1.06.07
- - import patch6 and patch100 from Fedora Extra(1.06.05-3) and build system is changed to cmake since autotools/make does not work
- rebuild against curl-7.16.0

* Fri Oct 20 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.04-2m)
- change autoreconf to each autotools

* Wed May 24 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.04-1m)
- update to  1.04

* Fri Apr 15 2005 Kazuhiko <kazuhiko@fdiary.net>
- (1.2-1m)
- initial import to Momonga
